#pragma once
#ifndef USE_MFCCONTAINER
#include <vector>
#endif

class CMFCStringStackDoc : public CDocument {
protected:
  CMFCStringStackDoc();
  DECLARE_DYNCREATE(CMFCStringStackDoc)

public:
  virtual BOOL OnNewDocument();
  virtual void Serialize(CArchive& ar);

public:
  virtual ~CMFCStringStackDoc();
#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

protected:
  DECLARE_MESSAGE_MAP()

public:
  void    Push(const CString& str);
  CString Pop(void);
  void    Clear(void);
  bool    Empty(void) const;
  int     Size() const;
  CString At(int index) const;

private:
#ifdef USE_MFCCONTAINER
  CArray<CString> container_;
#else
  std::vector<CString> container_;
#endif
};
