// MFCStringStackView.cpp : CMFCStringStackView NX̎
//

#include "stdafx.h"
#include "MFCStringStack.h"

#include "MFCStringStackDoc.h"
#include "MFCStringStackView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMFCStringStackView

IMPLEMENT_DYNCREATE(CMFCStringStackView, CFormView)

BEGIN_MESSAGE_MAP(CMFCStringStackView, CFormView)
    ON_BN_CLICKED(IDC_PUSH, &CMFCStringStackView::OnBnClickedPush)
    ON_BN_CLICKED(IDC_POP, &CMFCStringStackView::OnBnClickedPop)
    ON_BN_CLICKED(IDC_CLEAR, &CMFCStringStackView::OnBnClickedClear)
END_MESSAGE_MAP()

// CMFCStringStackView RXgNV/fXgNV

CMFCStringStackView::CMFCStringStackView() : CFormView(CMFCStringStackView::IDD) {
}

CMFCStringStackView::~CMFCStringStackView() {
}

void CMFCStringStackView::DoDataExchange(CDataExchange* pDX) {
  CFormView::DoDataExchange(pDX);
}

BOOL CMFCStringStackView::PreCreateWindow(CREATESTRUCT& cs) {
  return CFormView::PreCreateWindow(cs);
}

void CMFCStringStackView::OnInitialUpdate() {
  CFormView::OnInitialUpdate();
  GetParentFrame()->RecalcLayout();
  ResizeParentToFit();
}


// CMFCStringStackView ff

#ifdef _DEBUG
void CMFCStringStackView::AssertValid() const {
  CFormView::AssertValid();
}

void CMFCStringStackView::Dump(CDumpContext& dc) const {
  CFormView::Dump(dc);
}

CMFCStringStackDoc* CMFCStringStackView::GetDocument() const {
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMFCStringStackDoc)));
  return (CMFCStringStackDoc*)m_pDocument;
}
#endif //_DEBUG

// CMFCStringStackView bZ[W nh

void CMFCStringStackView::OnBnClickedPush() {
  CString str;
  GetDlgItem(IDC_STRING)->GetWindowText(str);
  GetDocument()->Push(str);
}

void CMFCStringStackView::OnBnClickedPop() {
  if ( !GetDocument()->Empty() ) {
    CString result = GetDocument()->Pop();
    GetDlgItem(IDC_STRING)->SetWindowText(result);
  }
}

void CMFCStringStackView::OnBnClickedClear() {
  GetDocument()->Clear();
}

void CMFCStringStackView::OnUpdate(CView*, LPARAM, CObject*) {
  CListBox* box = static_cast<CListBox*>(GetDlgItem(IDC_STACK));
  box->ResetContent();
  for ( int index = GetDocument()->Size() - 1; index >= 0; --index ) {
    box->AddString(GetDocument()->At(index));
  }
}
